VERTEX_START

precision highp float;
attribute vec3 Position;
attribute vec2 TexCoord0;
varying mediump vec2 Out_Tex0;
void main() {
  gl_Position = vec4(Position.xy, 0.0, 1.0);
  Out_Tex0 = vec2(TexCoord0.x, TexCoord0.y);
}

VERTEX_END

FRAGMENT_START

precision highp float;
uniform sampler2D Diffuse; 
uniform sampler2D BlurTexture;
uniform sampler2D DepthTexture;
varying mediump vec2 Out_Tex0;
uniform mediump vec3 u_settings;
uniform mediump float u_FarPlane;

float readDepth(vec2 coord)
{
    return 2.0 / ((800.0 - 1.0) + 2.0 - texture2D(DepthTexture, coord).r * (800.0 - 1.0));
}

void main() {
    vec3 colNormal = texture2D(Diffuse, Out_Tex0).rgb;
    vec3 colBlur = texture2D(BlurTexture, Out_Tex0).rgb;
    
    float depth = readDepth(Out_Tex0);
    float ratio = 1.0;
    
    if ( depth < u_settings.y || depth > u_settings.z) ratio = 0.0;
    
    depth = pow(depth, 0.30) * ratio;
    
    gl_FragColor.rgb = mix(colNormal, colBlur, depth);
    gl_FragColor.a = 1.0;
}

FRAGMENT_END