VERTEX_START

precision highp float;
attribute vec3 Position;
attribute vec2 TexCoord0;
varying mediump vec2 Out_Tex0;
void main() {
  gl_Position = vec4(Position.xy, 0.0, 1.0);
  Out_Tex0 = vec2(TexCoord0.x, TexCoord0.y);
}

VERTEX_END

FRAGMENT_START

precision highp float;
precision mediump int;
uniform sampler2D Diffuse;
varying vec2 Out_Tex0;
uniform mediump vec2 u_Blur;

void main() {
    float weights[5];
    weights[0] = 0.227027;
    weights[1] = 0.1945946;
    weights[2] = 0.1216216;
    weights[3] = 0.054054;
    weights[4] = 0.016216;

    vec2 tex_offset = u_Blur;
    vec3 result = texture2D(Diffuse, Out_Tex0).rgb * weights[0];

    for (int i = 1; i < 5; ++i) {
        vec2 offset = tex_offset * float(i) * 2.5;
        result += texture2D(Diffuse, Out_Tex0 + offset).rgb * weights[i];
        result += texture2D(Diffuse, Out_Tex0 - offset).rgb * weights[i];
    }
    
    gl_FragColor = vec4(result, 1.0);
}

FRAGMENT_END