VERTEX_START

precision highp float;
attribute vec3 Position;
attribute vec2 TexCoord0;
varying mediump vec2 Out_Tex0;
void main() {
  gl_Position = vec4(Position.xy, 0.0, 1.0);
  Out_Tex0 = vec2(TexCoord0.x, TexCoord0.y);
}

VERTEX_END

FRAGMENT_START

precision mediump float;
precision mediump int;
uniform sampler2D Diffuse;
uniform sampler2D BlurTexture;
varying mediump vec2 Out_Tex0;
uniform mediump vec2 u_settings;

#define Power (u_settings.x)
#define Chroma (u_settings.y) // Saturation

void main() {
    vec3 color1 = texture2D(Diffuse, Out_Tex0).rgb;
    vec3 color2 = texture2D(BlurTexture, Out_Tex0).rgb;
    
    const vec3 fLuminance = vec3(0.299, 0.587, 0.114);
    float lum = dot(color2.rgb, fLuminance);
    color2.rgb = mix(vec3(lum), color2.rgb, Chroma) * Power;
    
    gl_FragColor.rgb = color2 + color1;
    gl_FragColor.a	= 1.0;
}

FRAGMENT_END