VERTEX_START

precision highp float;
attribute vec3 Position;
attribute vec2 TexCoord0;
varying mediump vec2 Out_Tex0;
void main() {
  gl_Position = vec4(Position.xy, 0.0, 1.0);
  Out_Tex0 = vec2(TexCoord0.x, TexCoord0.y);
}

VERTEX_END

FRAGMENT_START

precision lowp float;
precision lowp int;
uniform sampler2D Diffuse;
varying vec2 Out_Tex0;
uniform mediump vec3 u_Blur;

#define Passes 5

void main() {
    float radius = u_Blur.z;
    vec2 tex_offset = u_Blur.xy;
    vec3 result = vec3(0.0);

    for (int i = 1; i < Passes; ++i) {
        float offset_scale = float(i) * radius;
        vec2 offset = tex_offset * offset_scale;
        result += texture2D(Diffuse, Out_Tex0 + offset).rgb;
        result += texture2D(Diffuse, Out_Tex0 - offset).rgb;
    }

    gl_FragColor = vec4(result / float(Passes * 2 - 2), 1.0);
}

FRAGMENT_END