VERTEX_START

precision highp float;
attribute vec3 Position;
attribute vec2 TexCoord0;
varying mediump vec2 Out_Tex0;
void main() {
  gl_Position = vec4(Position.xy, 0.0, 1.0);
  Out_Tex0 = vec2(TexCoord0.x, TexCoord0.y);
}

VERTEX_END

FRAGMENT_START

precision mediump float;
uniform sampler2D Diffuse;
varying mediump vec2 Out_Tex0;
uniform mediump vec2 u_settings;

#define Darkness (u_settings.x)
#define Chroma (u_settings.y)

void main() {
    vec3 result = texture2D(Diffuse, Out_Tex0).rgb;
    result = max(result - Darkness, vec3(0.0));
    
    gl_FragColor.rgb= result;
    gl_FragColor.a = 1.0;
}

FRAGMENT_END