VERTEX_START

precision highp float;
attribute vec3 Position;
attribute vec2 TexCoord0;
varying mediump vec2 Out_Tex0;
uniform mat4 u_ProjectionMatrix;
uniform mat4 u_ViewMatrix;
uniform mat4 u_ObjectMatrix;
void main() {
  vec4 WorldPos = u_ObjectMatrix * vec4(Position, 1.0);
  vec4 ViewPos = u_ViewMatrix * WorldPos;
  vec4 pPos = u_ProjectionMatrix * ViewPos;
  //gl_Position = pPos;
  gl_Position = vec4(Position.xy, 0.0, 1.0);
  Out_Tex0 = vec2(TexCoord0.x, TexCoord0.y);
}

VERTEX_END

FRAGMENT_START

precision mediump float;
precision mediump int;
uniform sampler2D Diffuse;
varying mediump vec2 Out_Tex0;
uniform mediump vec3 u_settings;
uniform mediump vec2 u_Resolution;

// taken from this: https://github.com/Mortalitas/GShade/blob/master/Shaders/Emboss.fx
void main() {
    float angleRad = radians(u_settings.z);
    
    vec2 offset = vec2(cos(angleRad), sin(angleRad)) * u_settings.y / u_Resolution;
    
    vec3 color = texture2D(Diffuse, Out_Tex0).rgb;
    vec3 col1 = texture2D(Diffuse, Out_Tex0 - offset).rgb;
    vec3 col3 = texture2D(Diffuse, Out_Tex0 + offset).rgb;
    
    vec3 colEmboss = col1 * 2.0 - color - col3;
    
    float colDot = max(0.0, dot(colEmboss, vec3(0.333))) * u_settings.x;
    
    vec3 colFinal = color - colDot;
    
    float luminance = dot(color, vec3(0.6, 0.2, 0.2));
    vec3 finalColor = mix(colFinal, color, luminance * luminance);
    
    gl_FragColor = vec4(finalColor, 1.0);
}

FRAGMENT_END