VERTEX_START

precision highp float;
attribute vec3 Position;
attribute vec2 TexCoord0;
varying mediump vec2 Out_Tex0;
void main() {
   gl_Position = vec4(Position.xy, 0.0, 1.0);
  Out_Tex0 = TexCoord0;
}

VERTEX_END

FRAGMENT_START

precision mediump float;
uniform sampler2D Diffuse;
uniform sampler2D PrevFrameTexture;
varying mediump vec2 Out_Tex0;
uniform mediump float u_settings;

void main() {
    vec3 currentColor = texture2D(Diffuse, Out_Tex0).rgb;
    vec3 previousColor = texture2D(PrevFrameTexture, Out_Tex0).rgb;
    vec3 blendedColor = mix(currentColor, previousColor, u_settings);
    
    gl_FragColor.rgb = blendedColor;
    gl_FragColor.a = 1.0;
}

FRAGMENT_END