VERTEX_START

precision highp float;
attribute vec3 Position;
attribute vec2 TexCoord0;
varying mediump vec2 Out_Tex0;
void main() {
  gl_Position = vec4(Position.xy, 0.0, 1.0);
  Out_Tex0 = vec2(TexCoord0.x, TexCoord0.y);
}

VERTEX_END

FRAGMENT_START

precision mediump float;
uniform sampler2D Diffuse;
varying mediump vec2 Out_Tex0;
uniform mediump vec2 u_settings;

// https://github.com/hrydgard/ppsspp/blob/master/assets/shaders/vignette.fsh
void main() {
    vec2 diff = Out_Tex0 - 0.5;
    diff.x *= u_settings.y;
    diff.y /= u_settings.y;
    float vignette = 1.0 - min(1.0, u_settings.x * (dot(diff, diff) * 2.0));
    vec3 rgb = texture2D(Diffuse, Out_Tex0.xy).xyz;
    rgb *= vignette;
    gl_FragColor.rgb = vignette * rgb;
    gl_FragColor.a = 1.0;
}

FRAGMENT_END